/* Hello FreeRTOS test application
 * Written by Jimmie Alam and Brian Birtles
 *
 * Tests that the most basic application (single process) can run under
 * our port of FreeRTOS
 */ 

#include <stdio.h>

/* Scheduler include files. */
#include "projdefs.h"
#include "portable.h"
#include "task.h"

static void vTestTask( void *pvParameters );

portSHORT main( void )
{
	sTaskCreate( vTestTask, "Hello", portMINIMAL_STACK_SIZE, NULL,
		tskIDLE_PRIORITY + 1, NULL );

	vTaskStartScheduler( pdFALSE );

	return 0;
}
/*-----------------------------------------------------------*/

static void vTestTask( void *pvParameters )
{
	printf("Hello FreeRTOS\n");
	printf("pvParameters: %d\n", pvParameters);

	/* Tasks must be implemented as continuous loops */
	while(1);
}
