/* 
 * Tests pre-emption
 */ 

#include <stdio.h>

/* Scheduler include files. */
#include "projdefs.h"
#include "portable.h"
#include "task.h"
#include "semphr.h"

static void vTestTask( void *pvParameters );
static int task1id = 1;
static int task2id = 2;
static int task3id = 3;
static int task4id = 4;
xSemaphoreHandle xSemaphore = NULL;

portSHORT main( void )
{
	sTaskCreate( vTestTask, "Task 1", 1000, (void *) &task1id,
		tskIDLE_PRIORITY + 2, NULL );
	sTaskCreate( vTestTask, "Task 2", 1000, (void *) &task2id,
		tskIDLE_PRIORITY + 2, NULL );
	sTaskCreate( vTestTask, "Task 3", 1000, (void *) &task3id,
		tskIDLE_PRIORITY + 2, NULL );
	sTaskCreate( vTestTask, "Task 4", 1000, (void *) &task4id,
		tskIDLE_PRIORITY + 2, NULL );

	printf("starting scheduler...\n");

	vSemaphoreCreateBinary( xSemaphore );
	vTaskStartScheduler( pdTRUE );

	return 0;
}
/*-----------------------------------------------------------*/

static void vTestTask( void *pvParameters )
{
	int taskId = *((int *)pvParameters);
	while(1)
	{
		if ( cSemaphoreTake( xSemaphore, 0 ) )
		{
			printf("Task %d running.\n", taskId);
			cSemaphoreGive( xSemaphore );
		}
	}
}
