/* Hello World test application
 *
 * Tests pre-emption
 */ 

#include <stdio.h>

/* Scheduler include files. */
#include "projdefs.h"
#include "portable.h"
#include "task.h"
#include "semphr.h"

static void customer( void *pvParameters );
static void barber( void *pvParameters );
static int task1id = 1;
static int task2id = 2;
static int task3id = 3;
static int task4id = 4;
xSemaphoreHandle xSemaphore = NULL;
xSemaphoreHandle xSemaphore1 = NULL;
xSemaphoreHandle xSemaphore2 = NULL;
xSemaphoreHandle xSemaphore3 = NULL;
portSHORT main( void )
{
	sTaskCreate( barber, "Task 1", 1000, (void *) &task1id, tskIDLE_PRIORITY + 2, NULL );
	sTaskCreate( customer, "Task 2", 1000, (void *) &task2id, tskIDLE_PRIORITY + 1, NULL );
	sTaskCreate( customer, "Task 3", 1000, (void *) &task3id, tskIDLE_PRIORITY + 2, NULL );
	sTaskCreate( customer, "Task 4", 1000, (void *) &task4id, tskIDLE_PRIORITY + 3, NULL );

	printf("starting scheduler...\n");

	vSemaphoreCreateBinary( xSemaphore );
        vSemaphoreCreateBinary( xSemaphore1 );
	vSemaphoreCreateBinary( xSemaphore2 );
        vSemaphoreCreateBinary( xSemaphore3 );
	vTaskStartScheduler( pdTRUE );

	printf("main done.\n");

	return 0;
}
/*-----------------------------------------------------------*/

static void customer( void *pvParameters )
{
	int taskId = *((int *)pvParameters);
	while(1)
	{
		if ( cSemaphoreTake( xSemaphore, 0 ) )
		{
		   if ( cSemaphoreTake( xSemaphore2, 0 ) )
		   {
			printf("Customer %d is being served.\n", taskId);
			cSemaphoreGive( xSemaphore1 );
                        cSemaphoreGive( xSemaphore2 );
                   }
		}
	}
}

static void barber( void *pvParameters )
{
        int taskId = *((int *)pvParameters);
        while(1)
        {
                if ( cSemaphoreTake( xSemaphore1, 0 ) )
                {
                   if ( cSemaphoreTake( xSemaphore2, 1000 ) )
	           {       
                        printf("Barber %d cutting hair.\n", taskId);
                        cSemaphoreGive( xSemaphore );
                        cSemaphoreGive( xSemaphore2 );
                   }
                }
        }
}

