/* 
 * Tests basic cooperative scheduling.
 */ 

#include <stdio.h>

/* Scheduler include files. */
#include "projdefs.h"
#include "portable.h"
#include "task.h"

static void vTestTask( void *pvParameters );
static int task1id = 1;
static int task2id = 2;

portSHORT main( void )
{
	sTaskCreate( vTestTask, "Task 1", 1000, (void *) &task1id,
		tskIDLE_PRIORITY + 2, NULL );
	sTaskCreate( vTestTask, "Task 2", 1000, (void *) &task2id,
		tskIDLE_PRIORITY + 2, NULL );

	printf("starting scheduler...\n");

	vTaskStartScheduler( pdFALSE );

	return 0;
}
/*-----------------------------------------------------------*/

static void vTestTask( void *pvParameters )
{
	int taskId = *((int *)pvParameters);
	printf("Task %d yielding.\n", taskId);
	taskYIELD();
	printf("Task %d resumed.\n", taskId);
	printf("Task %d yielding.\n", taskId);
	taskYIELD();
	printf("Task %d resumed.\n", taskId);

	/* Tasks must be implemented as continuous loops */
	while(1);
}
